import pandas as pd
from pandas_datareader import data
import datetime
import qqpat
import csv

def lastValue(x):
    try:
        reply = x[-1]
    except:
        reply = None
    return reply
    
system_list = ["sys0", "sys1", "sys2", "sys3", "sys4", "sys5"]

for index, system in enumerate(system_list):
    tradeTimes = []
    tradeBalance = []
    with open(system + ".txt", 'rb') as csvfile:
        reader = csv.reader(csvfile)
        for idx_data, row in enumerate(reader):
            if idx_data > 0:
                tradeTimes.append(datetime.datetime.strptime(row[3], '%d/%m/%Y %H:%M'))
                tradeBalance.append(float(row[10]))      
        if index == 0:
            data = pd.Series(data=tradeBalance, index=tradeTimes).resample('D', how=lastValue).pct_change(fill_method='pad').fillna(0)
        else:
            data = pd.concat([data, pd.Series(data=tradeBalance, index=tradeTimes).resample('D', how=lastValue).pct_change(fill_method='pad').fillna(0)], axis=1)
            
data = data.fillna(0.0)
                                     
analyzer = qqpat.Analizer(data, column_type='return', titles=system_list)
weights = analyzer.min_variance_portfolio_optimization(plotWeights=True)
analyzer.plot_analysis_portfolio_returns(weights)
analyzer.plot_analysis_returns()




